



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Qt带返回值的信号发射方式（使用QMetaObject::invokeMethod）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Qt带返回值的信号发射方式（使用QMetaObject::invokeMethod）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 09:58:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>一般来说，我们发出信号使用emit这个关键字来操作，但是会发现，emit并不算一个调用，所以它没有返回值。那么如果我们发出这个信号想获取一个返回值怎么办呢？</p>
<p>两个办法：1.通过出参形式返回，引用或者指针的方式带回；比如emit sig(int&amp; i)或者emit sig(void* pointer)，但是这个方法有一个弊端，稍后介绍第二种方式会提醒。</p>
<p>2.通过qt自带的invoke机制调用：参考文档对QMetaObject::invokeMethod的说明：Invokes the member (a signal or a slot name) on the object obj.也就是说回调是可以回调信号或者槽的。一般来说，我们使用invokeMethod是在子线程需要调度UI操作的时候(已经有很多文章详细说明了使用方式，不再赘述)，因为UI操作只能在主线程中使用(否则会出现未定义错误)，通过这种回调方式，让要操作的事件回到主线程时间片的时候再来执行。大部分情况下，我们把UI操作封装在一个槽里，用回调方式来调度。同样信号也可以用这种方式，但是有几点需要注意的是，1.调用回调的连接方式：如果信号和连接槽在一个线程内，那么必须用Qt::DirectConnection或者Qt::AutoConnection，这样的话，保证信号回调后，线程会等待信号连接槽执行完毕，才可能取到我们需要的返回值；如果使用了Qt::QueuedConnection，那么信号只是负责把事件交给事件队列，然后马上做出返回，这样，是否有返回值就无法确定了(这也就是第一个方法的弊端，因为信号发射是根据信号和槽各自的线程情况来选择的连接方式).如果信号和槽在两个线程中，那么首先肯定不能使用Qt::DirectConnection，除非你很清楚连接槽的动作是否保证了线程安全。但根据第一条的说明，也不能使用Qt::QueuedConnection。不过还好qt提供了一个额外的连接方式就是Qt::BlockingQueuedConnection，这个连接方式会阻塞住发射信号的线程一直等到队列连接槽返回后，才会恢复阻塞，这样就可以保证我们能拿到真正的返回值。(但是使用这种方式需要你清楚的知道，发射线程是否允许阻塞和连接槽是否对这个阻塞线程有什么特别的操作,一般来说，如果这个线程并不是由你自己控制的话，不要随便尝试去阻塞别人的线程，因为你并不清楚别人线程的执行逻辑)</p>
<p>调用方式大致代码如下bool bReturn;&nbsp;QMetaObject::invokeMethod(&amp;object, "sig", Qt::DirectConnection/*Qt::QueuedConnection*/, Q_RETURN_ARG(bool, bReturn), Q_ARG(int, i));</p>
</div>
<div>https://github.com/KaiMingPrince</div>
<div><a href="https://www.cnblogs.com/KaiMing-Prince/p/7967588.html" rel="external nofollow noreferrer">https://www.cnblogs.com/KaiMing-Prince/p/7967588.html</a></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495zw709.html">黑马程序员&lowbar;Java基础：多线程总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rk5xmq.html">《BI那点儿事》Microsoft 聚类分析算法&mdash;&mdash;三国人物身份划分</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42yy39.html">Thinkphp  整理备忘 杂记</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1o2748.html">DSP using MATLAB示例Example3&period;18</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdmwjvq.html">Buy Tickets（线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx00djq.html">JSON 字符串 与 java 对象的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnen6d8.html">php调试小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1om5z9.html">Linux下MySQL使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x7rnz8.html">汇编invoke和call的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xjre9.html">Sublime Text3自动保存的功能&lpar;失去焦点自动保存&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvnvdoq.html">About GAC</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1315q.html">GinWin命令控制台执行指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgdk38.html">memcache锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z7pp49.html">DSP开发资源总结&comma;经典书籍&comma;论坛</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn1mxoq.html">Linux中部署JAVA程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp27k0q.html">SVG---DEMO</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p1dwn8.html">一个故事讲清楚BIO NIO 异步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy45xxq.html">springMVC的全局异常设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/960dl7n9.html">Spring Boot 配置&lowbar;yaml语法介绍 day02</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllw1l1q.html">&lbrack;hdu P3085&rsqb; Nightmare Ⅱ</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qllk3v6q.html">vue实现部分页面导入底部 vue配置公用头部、底部，可控制显示隐藏</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wv4d0q.html">Android Glide 源码分析系列（待完成）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gwelvq.html">linux epoll学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/960yrwv9.html">记一次redis病毒分析笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2w0krq.html">常用xpath选择器和css选择器总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd57zz9.html">【iCore4 双核心板&lowbar;FPGA】例程十七：基于FIFO的ARM&plus;FPGA数据存取实验</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy4d419.html">android sdk manager更新地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4jn7j9.html">Tensorflow 与Caffe&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r51o64q.html">一文弄懂神经网络中的反向传播法&lpar;Backpropagation algorithm&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1ljvl9.html">【Dubbo 源码解析】08&lowbar;Dubbo与Spring结合</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
